<!DOCTYPE html>
<html lang="de">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Briefgenerator</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css" rel="stylesheet">
    <style>
        body {
            background: linear-gradient(to right, #f5f5f5, #e8eaec);
            color: #4f4f4f;
            font-family: 'Arial', sans-serif;
        }

        h1 {
            font-size: 3rem;
            font-weight: 600;
            margin-bottom: 2rem;
            color: #333;
        }

        .card {
            border-radius: 12px;
            border: none;
            background-color: rgba(235, 231, 231, 0.95);
            box-shadow: 0 4px 8px rgba(161, 156, 156, 0.15);
        }

        .card-header {
            background-color: #e2dfdf;
            color: #333;
            font-weight: bold;
            border-top-left-radius: 12px;
            border-top-right-radius: 12px;
            font-size: 1.2rem;
        }

        .card-body {
            padding: 2rem;
        }

        .btn {
            font-size: 1rem;
            padding: 10px 20px;
            border-radius: 30px;
            transition: background-color 0.3s ease;
        }

        .btn-primary {
            background-color: #6c7e91;
            border: none;
        }

        .btn-primary:hover {
            background-color: #475c72;
        }

        .btn-success {
            background-color: #8f7d4e;
            border: none;
        }

        .btn-success:hover {
            background-color: #7a6543;
        }

        .form-label {
            font-weight: 500;
        }

        #pdfPreview {
            display: none;
            margin-top: 2rem;
        }

        iframe {
            border-radius: 10px;
            border: none;
        }

        .alert {
            border-radius: 10px;
            font-weight: normal;
            padding: 1rem;
            margin-top: 1rem;
        }

        .alert-success {
            background-color: #d4edda;
            color: #3c763d;
        }

        .alert-danger {
            background-color: #f8d7da;
            color: #721c24;
        }

        .container {
            max-width: 900px;
            margin: 0 auto;
        }
    </style>
</head>
<body>
    <div class="container mt-5">
        <h1 class="text-center">Briefgenerator</h1>

        <!-- Upload PDF Form -->
        <div class="card mt-4">
            <div class="card-header">
                📄 PDF Hochladen
            </div>
            <div class="card-body">
                <form id="uploadForm" enctype="multipart/form-data">
                    <div class="mb-3">
                        <label for="file" class="form-label">Wählen Sie eine PDF-Datei</label>
                        <input type="file" class="form-control" id="file" name="file" required>
                    </div>
                    <button type="submit" class="btn btn-primary">PDF Hochladen und Verarbeiten</button>
                </form>
                <div id="uploadMessage" class="mt-3"></div>

                <!-- PDF Preview -->
                <div id="pdfPreview">
                    <h4>Vorschau des PDF:</h4>
                    <iframe id="pdfIframe" style="width: 100%; height: 500px;"></iframe>
                </div>
            </div>
        </div>

        <!-- Generate Letter Form -->
        <div class="card mt-4">
            <div class="card-header">
                ✍️ Brief Generieren
            </div>
            <div class="card-body">
                <!-- Individual buttons for each tool -->
                <button type="button" class="btn btn-primary mb-2" id="schreibenserstellerBtn">
                    📄 Schreibensersteller
                </button>
                <button type="button" class="btn btn-primary mb-2" id="berechnungsassistentBtn">
                    📊 Berechnungsassistent
                </button>
                <button type="button" class="btn btn-primary mb-2" id="dokumentenanfrageBtn">
                    🗂 Dokumentenanfrage
                </button>

                <!-- Placeholder for the generated letter content -->
                <div id="generatedLetter" class="mt-3"></div>
            </div>
        </div>

        <!-- Download Options -->
        <div class="card mt-4">
            <div class="card-header">
                📥 Brief Herunterladen
            </div>
            <div class="card-body">
                <form action="{{ url_for('download_letter', format='pdf') }}" method="POST">
                    <input type="hidden" name="section_content" value="{{ section_content }}">
                    <button type="submit" class="btn btn-success">Als PDF Herunterladen</button>
                </form>
                <br>
                <form action="{{ url_for('download_letter', format='docx') }}" method="POST">
                    <input type="hidden" name="section_content" value="{{ section_content }}">
                    <button type="submit" class="btn btn-success">Als DOCX Herunterladen</button>
                </form>
                <div id="downloadMessage" class="mt-3"></div>
            </div>
        </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/jquery@3.6.0/dist/jquery.min.js"></script>
    <script>
        // Handle PDF upload and processing
        $('#uploadForm').submit(function(e) {
            e.preventDefault();
            var formData = new FormData(this);
            $.ajax({
                url: '/upload',
                type: 'POST',
                data: formData,
                contentType: false,
                processData: false,
                success: function(response) {
                    $('#uploadMessage').html('<div class="alert alert-success">' + response.message + '</div>');
                },
                error: function(response) {
                    $('#uploadMessage').html('<div class="alert alert-danger">Fehler: ' + response.responseJSON.message + '</div>');
                }
            });
        });

        // Handle file selection for preview
        $('#file').change(function() {
            var file = this.files[0];
            var reader = new FileReader();
            reader.onload = function(e) {
                var pdfUrl = e.target.result;
                $('#pdfPreview').show();
                $('#pdfIframe').attr('src', pdfUrl);
            };
            reader.readAsDataURL(file);
        });

        // Handle letter generation when buttons are clicked
        $('#schreibenserstellerBtn').click(function() {
            generateLetter('Schreibensersteller');
        });

        $('#berechnungsassistentBtn').click(function() {
            generateLetter('Berechnungsassistent');
        });

        $('#dokumentenanfrageBtn').click(function() {
            generateLetter('Dokumentenanfrage');
        });

        // Function to generate the letter
        function generateLetter(tool) {
            $.ajax({
                url: '/generate',
                type: 'POST',
                contentType: 'application/json',
                data: JSON.stringify({ tool: tool }),
                success: function(response) {
                    $('#generatedLetter').html('<h4>Generierter Brief:</h4><div>' + response.content + '</div>');
                    if (response.status === 'In Progress') {
                        startPolling(tool);
                    }
                },
                error: function(response) {
                    $('#generatedLetter').html('<div class="alert alert-danger">Fehler: ' + response.responseJSON.error + '</div>');
                }
            });
        }

        // Polling function to check for result availability
        function startPolling(tool) {
            const interval = setInterval(function() {
                $.ajax({
                    url: '/generate',
                    type: 'POST',
                    contentType: 'application/json',
                    data: JSON.stringify({ tool: tool }),
                    success: function(response) {
                        $('#generatedLetter').html('<h4>Generierter Brief:</h4><div>' + response.content + '</div>');
                        if (response.status === 'Completed') {
                            clearInterval(interval);
                        }
                    },
                    error: function(response) {
                        $('#generatedLetter').html('<div class="alert alert-danger">Fehler: ' + response.responseJSON.error + '</div>');
                    }
                });
            }, 2000);
        }
    </script>
</body>
</html>
